#include <stdio.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt_internal/int.h"
#include "tadt/ext.h"

/*
#define TESTING
*/

#ifdef TESTING
static int numoftrials = 1; /*300*/;
#else
static int numoftrials = 100; /*300*/;
#endif

unsigned short c_to_p[0x10000];
static dist_space_type uniform;

int main() {
  ind_space_type ev1, ev2;
  int i, j, k;
  bool before(), eval;
  void printf(), gettimeofday();
  struct timeval tp1, tp2;
  int temp1, temp2;

  eval = TRUE;
  temp1 = 1;
  for (i=SIG_BITS; i>0; i--) temp1 = temp1*2;

  for (i=DIST_MIN; i<=DIST_MAX; i++) uniform.floor[i] = (temp1*(i+1))/(DIST_MAX + 1);
  for (i=DIST_MIN; i<=DIST_MAX; i++) uniform.ceiling[DIST_MAX - i] = (temp1*(DIST_MAX - i))/(DIST_MAX + 1);
    /*
    uniform.ceiling[i] = (temp1*(i))/DIST_MAX;
    if ((temp1*(i)) % DIST_MAX) uniform.ceiling[i]++;
    }
    */
  uniform.floor[DIST_MAX] = temp1 - 1;

  j = DIST_MIN;
  for (i=0;i<temp1;i++) {
     c_to_p[i] = j;
     if (i >= uniform.floor[j]) j++;
     }
  for (i=DIST_MIN;i<=DIST_MAX;i++) c_to_p[uniform.floor[i]] = i;
  c_to_p[0] = 0;
  c_to_p[MAX_SC] = DIST_MAX;

  /*
  for (i=DIST_MIN;i<=DIST_MAX;i++) printf("%d %d\n",uniform.floor[i], uniform.ceiling[i]);
  for (i=0;i<temp1;i++) if (c_to_p[i] != 0) printf("%d %d\n", i, c_to_p[i]);
  exit();
  */

  /* event_type(1, 2000000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev1.start = 1;
  ev1.finish = 2000000;
  ev1.dist = &uniform;

  /* event_type(1000001, 3000000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev2.start = 1;
  ev2.finish = 2000000;
  ev2.dist = &uniform;

  /* event_type(1, 2000000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  /*
  ev2.start= 1000001;
  ev2.finish = 3000000;
  ev2.dist = &uniform;
  */


#ifdef TESTING
  ev1.start = 6000001;
  ev1.finish = 8000000;
  ev2.start = 6000001;
  ev2.finish = 8000000;
#endif

  printf("ev1->finish %x %x ev2->start %x %x\n", ev1.finish, ev2.start);

  adjust(100, &ev1, &ev2, &ev1, &ev2);
  shrink_l(100,&ev1,&ev1);
  shrink_r(100,&ev1,&ev1);

#ifdef TESTING
  for (k=0;k<1;k++) {
#else
  for (k=0;k<1;k++) {
#endif

#ifdef TESTING
    printf("%d %d %d %d\n", ev1.start, ev1.finish);
    printf("%d %d %d %d\n", ev2.start, ev2.finish);
#endif

    for (i=1;i<=100;i++) {

      gettimeofday(&tp1,NULL);

      for (j=0; j<numoftrials; j++) eval = before(i, &ev1, &ev2);

      gettimeofday(&tp2,NULL);

      temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
      temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
      temp1 = temp2 - temp1;

#ifdef TESTING
      if (eval) printf("TRUE %d %d ", k, i);
      else printf("False %d %d ", k, i);
#endif
      printf("%d\n", (temp1/numoftrials));

      }

#ifdef TESTING
    ev1.start += 250000;
    ev1.finish += 250000;
#endif
    }
  return TRUE;
}

/*
static void dump_ind_event(ind_type ev)
{
  void printf();
  printf("start %d\nfinish %d\nrange %d\nleft_offset %d\nright_offset %d\n",
         ev->start, ev->finish, ev->range, ev->left_offset, ev->right_offset);
}
*/
