/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/calendar/gregorian/gregorian_convert.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef gregorian_convert
#define gregorian_convert
/* convert.h
*
*  This module contains functions supporting variable span
*  to fixed span conversion.
*
*/

/*
*  Routine:  cal_standard_gregorian_v1_vs_to_fs
*
*  Description:  Converts a variable span to an equivalent fixed span
*
*  Arguments: vs     --    (IN) : variable span
*             fs     --    (OUT): fixed span
*
*  Return Value: Error code
*
*  Errors: semantic_error 
*
*  Side Effects: Overwrites fs
*/

error_type cal_standard_gregorian_v1_vs_to_fs(span_type vs, span_type fs);
#endif
