#include "../tadt/int64.h"

#define ADD32(x,y,z) (z) = (x) + (y)
#define SUB32(x,y,z) (z) = (x) - (y)
#define MULT32(x,y,z) (z) = (x) * (y)
#define DIV32(x,y,z) (z) = (x) / (y)
#define FDIV32(x,y,z) (z) = (x) / (y)
#define LOAD32(x,y) (y) = (x)
#define EQ32(x,y) (x) == (y)
#define GT32(x,y) (x) > (y)
#define LT32(x,y) (x) < (y)
#define LEQ32(x,y) (x) <= (y)
#define GEQ32(x,y) (x) >= (y)
#define CONSTRUCT32(x,y) (y) = (x)
#define ASSIGN32(x,y) (y) = (x)

#define ADD64(x,y,z) int64_add(x,y,z)
#define SUB64(x,y,z) int64_sub(x,y,z)
#define MULT64(x,y,z) int64_mul(x,y,z)
#define DIV64(x,y,z) int64_div(x,y,z)
#define FDIV64(x,y,z) int64_div(x,y,z)
#define LOAD64(x,y) int32_to_int64(x,y)
#define EQ64(x,y) (y) == (x)
#define GT64(x,y) (y) > (x)
#define LT64(x,y) (y) < (x)
#define LEQ64(x,y) (y) <= (x)
#define GEQ64(x,y) (y) >= (x)
#define CONSTRUCT64(low,hi,y) {\
	  int64 j64, i64, k64; \
          LOAD64(low,i64); \
          LOAD64(hi,j64); \
	  int64_shift_left(i64,32,k64); \
	  int64_add(k64,j64,y); \
	  }
#define ASSIGN64(x,y) int64_assign(x,y)

#define ADD96(x,y,z) ADD32(x,y,z)
#define SUB96(x,y,z) SUB32(x,y,z)   
#define MULT96(x,y,z) MULT32(x,y,z)   
#define DIV96(x,y,z) DIV32(x,y,z)   
#define FDIV96(x,y,z) DIV32(x,y,z)   
#define LOAD96(x,y) LOAD32(x,y)   
#define LOAD96_FROM_64(x,y) LOAD32(x,y)   
#define EQ96(x,y) EQ32(x,y)   
#define GT96(x,y) GT32(x,y)   
#define LT96(x,y) LT32(x,y)   
#define LEQ96(x,y) LEQ32(x,y)   
#define GEQ96(x,y) GEQ32(x,y)   
#define CONSTRUCT96(low,mid,hi,y) CONSTRUCT32(low,y)
#define ASSIGN96(x,y) ASSIGN32(x,y)

