/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/aggregate.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef ucs_aggregate
#define ucs_aggregate

/* aggregate.h
*
*  This module implements UCS support for span aggregate
*  computations.  Routines in this module are called by 
*  the query processing system when computing aggregate
*  functions on span columns.
*
*/

int *ucs_init_count_s();
error_type ucs_accum_count_s(int *count_state, span_type span);
error_type ucs_final_count_s(int final_state, int *final_count);

ucs_sum_state_s *ucs_init_sum_s();
error_type ucs_accum_sum_s(ucs_sum_state_s *sum_state, span_type span);
error_type ucs_final_sum_s(ucs_sum_state_s *final_s, span_type final_span_sum);

ucs_avg_state_s *ucs_init_avg_s();
error_type ucs_accum_avg_s(ucs_avg_state_s *avg_state, span_type span);
error_type ucs_final_avg_s(ucs_avg_state_s *final_state, span_type final_avg_span);

ucs_max_state_s *ucs_init_max_s();
error_type ucs_accum_max_s(ucs_max_state_s *max_state, span_type span);
error_type ucs_final_max_s(ucs_max_state_s *final_state, span_type final_max_span);

ucs_min_state_s *ucs_init_min_s();
error_type ucs_accum_min_s(ucs_min_state_s *min_state, span_type span);
error_type ucs_final_min_s(ucs_min_state_s *final_state, span_type final_min_span);
#endif
