/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/allocation.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef ucs_allocation
#define ucs_allocation

#include "property.h"
/* allocation.h
*
*  This module implements UCS memory allocation routines
*  All of the allocation that the UCS performs is done here.
*  Routines in this file are only called by other UCS routines.
*  These routines themselves call tadt_malloc and tadt_free to do the 
*  actual allocation.
*
*/

calendar_type *ucs_allocate_cal_type();

function_entry_type *ucs_allocate_function_table_type();

epoch_type *ucs_allocate_epoch_type(int num);

calendric_system_type *ucs_allocate_calendric_system_type();

ucs_sum_state_s *ucs_allocate_sum_state_s();

ucs_avg_state_s *ucs_allocate_avg_state_s();

ucs_min_state_s *ucs_allocate_min_state_s();

ucs_max_state_s *ucs_allocate_max_state_s();

property_element_type *ucs_allocate_property_element_type();

property_type *ucs_allocate_property_type();

#endif
