/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/error.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef ucs_error
#define ucs_error

typedef enum {
    ucs_ok,
    ucs_string_invalid, /* input event, interval or span invalid */
    ucs_incompatible_types, /* incompatible types on function bind */
    ucs_function_not_found, /* function not found on function bind */
    ucs_invalid_property, /* attempt to push an invalid calendar property */
    ucs_table_overflow, /* stack full on push */
    ucs_table_underflow, /* stack empty on pop */  
    ucs_incorrect_number_of_args, /* on function binding, arg cnt mismatch */
    ucs_string_overflow, /* too many characters for a string to hold */
} ucs_error_type;

#endif
