/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/multiplex.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef multiplex_include
#define multiplex_include
/* this file defines the multiple calendar table format this is
 *  used in the ucs to multiplex between different calendars
 *
 *  It was automatically generated by create_header.icn
 *
 */
#define num_calendars 1
#define num_cal_functions 49





typedef union {
	 error_type 	 (*F1)(void*a);
	 error_type 	 (*F2)(void*a,void*b);
	 error_type 	 (*F3)(void*a,void*b,void*c);
	 error_type 	 (*F3viv)(void*a,int b,void*c);
	 error_type 	 (*F3vdv)(void*a,double b,void*c);
} function_ptr;

extern function_ptr cal_table[num_cal_functions][num_calendars];





typedef enum {
	 ucs_gregorian,
	 ucs_time_card,
} ucs_calendar_names;


typedef enum {
	cal_count_fstate_to_vstate,
	cal_accum_count_s,
	cal_final_count_s,
	cal_sum_fstate_to_vstate,
	cal_accum_sum_s,
	cal_final_sum_s,
	cal_avg_fstate_to_vstate,
	cal_accum_avg_s,
	cal_final_avg_s,
	cal_max_fstate_to_vstate,
	cal_accum_max_s,
	cal_final_max_s,
	cal_min_fstate_to_vstate,
	cal_accum_min_s,
	cal_final_min_s,
	cal_neg_s,
	cal_vs_add_fs,
	cal_vs_add_vs,
	cal_vs_minus_fs,
	cal_fs_minus_vs,
	cal_vs_minus_vs,
	cal_vs_add_e,
	cal_e_minus_vs,
	cal_vs_times_n,
	cal_vs_div_n,
	cal_fs_div_vs,
	cal_vs_div_fs,
	cal_vs_div_vs,
	cal_vs_add_i,
	cal_i_minus_vs,
	cal_vs_to_fs,
	cal_gen_s_array,
	cal_gen_e_array,
	cal_gen_i_array,
	cal_allocate_sum_state_vs,
	cal_allocate_avg_state_vs,
	cal_allocate_min_state_vs,
	cal_allocate_max_state_vs,
	cal_vs_eq_fs,
	cal_vs_eq_vs,
	cal_vs_lt_fs,
	cal_fs_lt_vs,
	cal_vs_lt_vs,
	cal_fs_gt_vs,
	cal_vs_gt_fs,
	cal_vs_gt_vs,
	cal_gen_s_timestamp,
	cal_gen_e_timestamp,
	cal_gen_i_timestamp,
} ucs_cal_function_names;

#endif
