/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/property_internal.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef property_internal_include
#define property_internal_include

#define bad_name -1

#define group_start '<'
#define group_end   '>'



#define coded_name_table        1
#define coded_name_table_format 2

#define list_separator ','

#define lthan_escape "<<"
#define gthan_escape ">>"

#define pname_second "second"
#define pname_minute "minute"
#define pname_hour   "hour"
#define pname_day    "day"
#define pname_month  "month"
#define pname_year   "year"
#define pname_nano   "nanosecond"
#define pname_micro  "microsecond"
#define pname_milli  "millisecond"
#define pname_day_part "daypart" /* either am or pm */

#define tname_arabic_numbers "arabicnumber"

typedef struct {
    int  number;
    char string[max_property_name];
} name_struct;



int lookup_pnumber(int);
int lookup_tnumber(int);
int lookup_pname(char  *str);
int lookup_tname(char *str);
int encode_format(string_struct str, encoded_format_type *coded);
int decode_format(encoded_format_type *coded,string_struct str);


/*
 * implementation of property values
 *
 */


extern char *ucs_char_property_init_val[];
extern char *ucs_char_property_name[];


typedef struct PROP_NODE {
    struct PROP_NODE *next;
    property_type prop;
} prop_node;    


typedef struct PROP_MARKER {
    struct PROP_MARKER *next, *prev;
    prop_node *prop_list;
} prop_marker;


void property_init();

extern prop_marker *ucs_front_properties, *ucs_end_properties;

extern prop_node *initial_property_list[NUM_PROPERTIES];
extern bool ucs_non_activated_props;


#endif
