/* Test code for the determinate sequence */
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt.h"
#define EVENTS_IN_R 4
#define INTERVALS_IN_P 4
#define NUM_OF_TRIALS 1
#define NUM_OF_GAMMAS 100
/*
#define NUM_OF_WIDTHS 108
#define MAX_WIDTH 108
*/
#define NUM_OF_WIDTHS 108
/*
#define NUM_OF_RUNS 100
*/
#define NUM_OF_RUNS 20
static int widths[NUM_OF_WIDTHS];
static timings[NUM_OF_WIDTHS];
#define SEED 0x2F678324
#define PERIOD_OF_INDETERMINACY 24



context_space_type context_space;
context_type context = &context_space;

int main()
{
  packed_event_space_type received[EVENTS_IN_R];
  event_space_type received_upack[EVENTS_IN_R];
  packed_event_space_type starting_in_production[INTERVALS_IN_P];
  packed_event_space_type terminating_in_production[INTERVALS_IN_P];
  event_space_type starting_in_production_upack[INTERVALS_IN_P];
  event_space_type terminating_in_production_upack[INTERVALS_IN_P];
  interval_space_type in_production[INTERVALS_IN_P];
  interval_space_type in_production_upack[INTERVALS_IN_P];
  int k, x, j, i, r, p, temp;
  void gettimeofday();
  struct timeval tp1, tp2;
  int temp1, temp2;

  context->precision.precision = 5;

  error_handler();
  tadt_init();

  /* Initialize Recieved */
  for (i=0;i<EVENTS_IN_R;i++) {
    received[i].determinate.ts_type = packed_determinate;
    received[i].determinate.sign = 0;
    }

  received[0].determinate.data = (31+28+31+30+10)*86400;
  received[1].determinate.data = (31+28+31+30+30)*86400;
  received[2].determinate.data = (31+28+31+30+31+8)*86400;
  received[3].determinate.data = (31+28+31+30+31+13)*86400;

  /* Initialize In_Production */
  for (i=0;i<INTERVALS_IN_P;i++) {
    starting_in_production[i].determinate.ts_type = packed_determinate;
    starting_in_production[i].determinate.sign = 0;
    terminating_in_production[i].determinate.ts_type = packed_determinate;
    terminating_in_production[i].determinate.sign = 0;
    }

  starting_in_production[0].determinate.data = (31+28+1)*86400;
  starting_in_production[1].determinate.data = (31+28+31+30+31+1)*86400;
  starting_in_production[2].determinate.data = (31+28+31+30+31+1)*86400;
  starting_in_production[3].determinate.data = (31+28+31+1)*86400;

  terminating_in_production[0].determinate.data = (31+28+31+30+31+1)*86400;
  terminating_in_production[1].determinate.data = (31+28+31+30+31+30+1)*86400;
  terminating_in_production[2].determinate.data = (31+28+31+30+31+30+31+1)*86400;
  terminating_in_production[3].determinate.data = (31+28+31+30+1)*86400;

  for (i=0;i<INTERVALS_IN_P;i++) {
    in_production[i].start = (event_type)&starting_in_production[i];
    in_production[i].terminate = (event_type)&terminating_in_production[i];
    in_production_upack[i].start = &starting_in_production_upack[i];
    in_production_upack[i].terminate = &terminating_in_production_upack[i];
    }

  /*
  for (r=0;r<EVENTS_IN_R;r++) dump_event(&received[r]," event ");
  for (r=0;r<INTERVALS_IN_P;r++) dump_event(&starting_in_production[r]," start ");
  for (r=0;r<INTERVALS_IN_P;r++) dump_event(&starting_in_production[r]," terminate ");
  */

temp = 0;
/* From AVERAGE */
  for (i=0;i<NUM_OF_WIDTHS;i++) {
    widths[i] = i*25 * PERIOD_OF_INDETERMINACY + 1;
    timings[i] = 0;
    }

  for (k=0;k<NUM_OF_WIDTHS;k++) {

    for (x=0;x<NUM_OF_RUNS;x++) {
      for (i=1;i<=NUM_OF_GAMMAS;i++) {

        for (j=0;j<EVENTS_IN_R;j++) {
          temp1 = rand() % widths[k];
          received[j].determinate.data = temp1 + 1;
          }

        for (j=0;j<INTERVALS_IN_P;j++) {
          temp1 = rand() % widths[k];
          starting_in_production[j].determinate.data = temp1 + 1;
          temp1 = rand() % widths[k];
          terminating_in_production[j].determinate.data = temp1 + 1;
          }

        gettimeofday(&tp1,NULL);

        for (j=0;j<NUM_OF_TRIALS;j++) {

          for (p=0;p<INTERVALS_IN_P;p++) temp1 += p;
          for (r=0;r<EVENTS_IN_R;r++) temp1 += r;
          for (p=0;p<INTERVALS_IN_P;p++) 
            for (r=0;r<EVENTS_IN_R;r++) temp += r;
          }
      gettimeofday(&tp2,NULL);

      temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
      temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
      temp1 = temp2 - temp1;

       /*
        timings[k] += temp1/(NUM_OF_TRIALS*NUM_OF_EVENTS*NUM_OF_EVENTS);
        */
        timings[k] += temp1;

        }
      }
      fprintf(stderr,"%d\n", k);
    }

  for (k=0;k<NUM_OF_WIDTHS;k++) {
    printf("%d\n", timings[k]/(12*100*NUM_OF_RUNS));
    /*
    printf("%d\n", timings[k]);
    */
    }
  return FALSE;
/* END  From AVERAGE */


}
